"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#Delay
         instanceVariableNames:'milliseconds'
         classVariableNames:''
         poolDictionaries:''
         category:'Kernel-Processes'
!

Delay comment:'
COPYRIGHT (c) 1993 by Claus Gittinger
	      All Rights Reserved
'!

!Delay class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libbasic/Delay.st,v 1.5 1994-06-02 16:19:52 claus Exp $
"
!

documentation
"
    Instances of Delay are used to suspend the execution of a process (i.e.
    thread) for some time interval. Delays are created for some milli-
    second or second interval, and can later be waited upon.
"
! !

!Delay class methodsFor:'instance creation'!

forMilliseconds:aNumber
    "return a new Delay object for delaying aNumber milliseconds"

    ^ self new milliseconds:aNumber
!

forSeconds:aNumber
    "return a new Delay object for delaying aNumber seconds"

    ^ self new milliseconds:(aNumber * 1000)
! !

!Delay methodsFor:'accessing'!

milliseconds:aNumber
    "set the milliseconds"

    milliseconds := aNumber
! !

!Delay methodsFor:'delaying'!

wait
    "suspend the current process"

    |sema|

    sema := Semaphore new.
    Processor activeProcess state:#timeWait.
    Processor enableSemaphore:sema afterMilliseconds:milliseconds.
    sema wait

    "
     '1' printNewline.
     (Delay forSeconds:10) wait.
     '2' printNewline
    "
! !
