"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

AbsoluteTime subclass:#Time
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Magnitude-General'
!

Time comment:'
COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved
'!

!Time class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libbasic/Time.st,v 1.9 1994-06-02 16:22:29 claus Exp $
"
!

documentation
"
    Instances of time represent a particular time-of-day.
"
! !

!Time class methodsFor:'instance creation'!

now
    "return an instance of Time representing this moment"

    ^ self basicNew setSecondsLow:(OperatingSystem getTimeLow)
                              and:(OperatingSystem getTimeHi)
!

fromOSTime:osTime
    "return a time, representing the time given by the operatingSystem time"

    ^ self basicNew setSecondsLow:(osTime at:1) and:(osTime at:2)
! !

!Time class methodsFor:'ST-80 compatibility'!

fromSeconds: seconds
    "return a Time that is constructed from seconds since midnight."

   ^ (self new setSeconds:seconds) subtractTime: "60*60" 3600

    "midnight starts at 1:00:00 in ST/X for some strange reason"
!

totalSeconds
    ^ self secondClock
! !


!Time methodsFor:'ST-80 compatibility'!

asSeconds
        "Answer the number of seconds elapsed since midnight"

        ^ ( 3600 * (self hourInDay)   )
          + ( 60 * (self minuteInDay) )
          +        (self secondInDay)
!

hours
        "Answer the number of hours"

        ^self hourInDay
!

minutes
        "Answer the number of minutes"

        ^self minuteInDay
!

seconds
        "Answer the number of seconds"

        ^self secondInDay
! !

!Time methodsFor:'comparing'!

> aTime
    (aTime isMemberOf:Time) ifTrue:[
        (secondsHi > aTime secondsHi) ifTrue:[^ true].
        (secondsHi < aTime secondsHi) ifTrue:[^ false].
        (secondsLow > aTime secondsLow) ifTrue:[^ true].
        ^ false
    ].
    ^ self getSeconds > aTime getSeconds
!

< aTime
    (aTime isMemberOf:Time) ifTrue:[
        (secondsHi < aTime secondsHi) ifTrue:[^ true].
        (secondsHi > aTime secondsHi) ifTrue:[^ false].
        (secondsLow < aTime secondsLow) ifTrue:[^ true].
        ^ false
    ].
    ^ self getSeconds < aTime getSeconds
!

= aTime
    (aTime isMemberOf:Time) ifTrue:[
        ^ ((secondsLow == aTime secondsLow) and:[secondsHi == aTime secondsHi])
    ].
    ^ self getSeconds = aTime getSeconds
! !

!Time methodsFor:'printing'!

printOn:aStream
    aStream nextPutAll:self printString
!

printString
    |aString|

    OperatingSystem computeTimePartsOf:secondsLow and:secondsHi for:[
        :hours :minutes :secs |

        aString := hours printString , ':' .
        (minutes < 10) ifTrue:[aString := aString , '0'].
        aString := aString , minutes printString.
        aString := aString , ':'.
        (secs < 10) ifTrue:[aString := aString , '0'].
        aString := aString , secs printString
    ].
    ^ aString
! !
